﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.OleDb;

namespace WebApps
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                BindData();
            }
        }

        private void BindData()
        {
            string connectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Employees.xls;Extended Properties=Excel 8.0;";

            OleDbConnection conn = new OleDbConnection(connectionString);
            OleDbDataAdapter ad = new OleDbDataAdapter("SELECT * FROM [Sheet1$]", conn);

            DataSet ds = new DataSet();
            ad.Fill(ds);

            gvEmployees.DataSource = ds;
            gvEmployees.DataBind();

        }

        protected void gvEmployees_RowEditing(object sender, GridViewEditEventArgs e)
        {
            gvEmployees.EditIndex = e.NewEditIndex;
            BindData(); 

        }

        protected void gvEmployees_RowUpdating(object sender, GridViewUpdateEventArgs e)
        {
            GridViewRow row = gvEmployees.Rows[e.RowIndex];

            string firstName = (row.FindControl("txtFirstName") as TextBox).Text;
            string lastName = (row.FindControl("txtLastName") as TextBox).Text;
            string email = (row.FindControl("lblEmail") as Label).Text;

            Update(firstName, lastName, email);

            gvEmployees.EditIndex = -1;
            BindData(); 

        }

        protected void gvEmployees_RowCancelingEdit(object sender, GridViewCancelEditEventArgs e)
        {
            gvEmployees.EditIndex = -1;
            BindData(); 
        }

        private void Update(string firstName, string lastName, string email)
        {
            string connectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Employees.xls;Extended Properties=Excel 8.0;";

            string query = "UPDATE [Sheet1$] SET FirstName = @FirstName, LastName = @LastName WHERE Email = @Email";

            OleDbConnection conn = new OleDbConnection(connectionString);
            OleDbCommand command = new OleDbCommand(query,conn);
            command.Parameters.AddWithValue("@FirstName", firstName);
            command.Parameters.AddWithValue("@LastName", lastName);
            command.Parameters.AddWithValue("@Email", email);

            conn.Open();
            command.ExecuteNonQuery();
            conn.Close(); 
        }


    }
}
